#!/usr/bin/awk -f

# Copyright 2002 Jose Nazario <jose@monkey.org>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
BEGIN {
        print "<table cellpadding=5 cellspacing=0 border=0 width=\"100%\">"
        print "<tr><td>"
        print "<strong>Time</strong></td><td>"
	system("date")
	print "</td>"
        print "</tr>"
	print "</table>"
	print "<table cellpadding=2 cellspacing=5 border=0 width=\"100%\">"
	print "<tr><td bgcolor=\"#999999\">arpwatch</td></tr>"
	print "<tr><td><font size=-1>"
	print "<strong>MAC address</strong></td>"
	print "<td><strong>IP address</strong></td>"
	print "<td><strong>Time (sec)</strong></td>"
	print "<td><strong>Hostname</strong></font></td></tr>"
}
{
	# MAC address
	if (NR%2) {
		print "<tr><td>"
	} else {
		 print "<tr><td bgcolor=\"#bbbbbb\">"
	}
	print $1

	# IP
	if (NR%2) {
		print "<td>"
	} else {
		 print "<td bgcolor=\"#bbbbbb\">"
	}

	# XXX
	# timestamp
	print $2
	if (NR%2) {
		print "<td>"
	} else {
		 print "<td bgcolor=\"#bbbbbb\">"
	}
	print $3

	# hostname, if known
	if (NR%2) {
		print "<td>"
	} else {
		 print "<td bgcolor=\"#bbbbbb\">"
	}
	print $4
	print "</td></tr>"
}
END {
	print "</table>"
	# prepare the arp tables for next time
	system("cp /var/arpwatch/arp-sis0.dat arp-sis0.bak")
}
